(* Wes Weimer - CS 655 - Spring 2006
 *
 * This is a driver file for the homework 2 project. 
 *
 * Do not edit this file -- instead, edit hw2.ml and submit that as per the
 * directions in the homework. 
 *)
open Printf

let main () = 
  let silent = ref false in 
  let args = [
    "--silent", Arg.Set silent, "do not display a prompt or reminder"
  ] in 
  Arg.parse args (fun _ -> ()) "" ; 

  if not !silent then begin 
    printf "Enter an IMP command (use . to end your command):\n" ;
    flush stdout ; 
  end ; 
  let lexbuf = Lexing.from_channel stdin in
  let imp_command = Parse.com Lex.initial lexbuf in
  if not !silent then begin 
    print_endline (Imp.com_to_str imp_command) ; 
  end ; 
  let sigma_0 = Hw2.initial_state () in 
  let sigma_n = Hw2.eval_com imp_command sigma_0 in
  (match sigma_n with
  | Hw2.Normal(_) -> ()
  | Hw2.Exceptional(_,n) -> printf " *** Uncaught Exception %d" n ) ; 
  print_endline "" ; 
  exit 0 
;;
main () ;;
